Package com.google.protobuf

## Class DescriptorProtos.MethodDescriptorProto

- java.lang.Object
- - com.google.protobuf.AbstractMessageLite
  - - com.google.protobuf.AbstractMessage
    - - com.google.protobuf.GeneratedMessage
      - - com.google.protobuf.DescriptorProtos.MethodDescriptorProto

All Implemented Interfaces:
  `DescriptorProtos.MethodDescriptorProtoOrBuilder`, `Message`, `MessageLite`, `MessageLiteOrBuilder`, `MessageOrBuilder`, `java.io.Serializable`

Enclosing class:
  DescriptorProtos

    public static final class DescriptorProtos.MethodDescriptorProto
    extends GeneratedMessage
    implements DescriptorProtos.MethodDescriptorProtoOrBuilder

Protobuf type `google.protobuf.MethodDescriptorProto`

     Describes a method of a service.

See Also:
  Serialized Form

### Nested Class Summary

Nested Classes
`static class` `DescriptorProtos.MethodDescriptorProto.Builder` Protobuf type `google.protobuf.MethodDescriptorProto`

### Nested classes/interfaces inherited from class com.google.protobuf.GeneratedMessage

`GeneratedMessage.BuilderParent, GeneratedMessage.ExtendableBuilder<MessageType extends GeneratedMessage.ExtendableMessage,​BuilderType extends GeneratedMessage.ExtendableBuilder>, GeneratedMessage.ExtendableMessage<MessageType extends GeneratedMessage.ExtendableMessage>, GeneratedMessage.ExtendableMessageOrBuilder<MessageType extends GeneratedMessage.ExtendableMessage>, GeneratedMessage.FieldAccessorTable, GeneratedMessage.GeneratedExtension<ContainingType extends Message,​Type>`

### Field Summary

Fields
`static int` `INPUT_TYPE_FIELD_NUMBER`
`static int` `NAME_FIELD_NUMBER`
`static int` `OPTIONS_FIELD_NUMBER`
`static int` `OUTPUT_TYPE_FIELD_NUMBER`
`static Parser<DescriptorProtos.MethodDescriptorProto>` `PARSER`

### Fields inherited from class com.google.protobuf.GeneratedMessage

`alwaysUseFieldBuilders`

### Fields inherited from class com.google.protobuf.AbstractMessageLite

`memoizedHashCode`

### Method Summary

All Methods Static Methods Instance Methods Concrete Methods
`static DescriptorProtos.MethodDescriptorProto` `getDefaultInstance()`
`DescriptorProtos.MethodDescriptorProto` `getDefaultInstanceForType()` Get an instance of the type with no fields set.
`static Descriptors.Descriptor` `getDescriptor()`
`java.lang.String` `getInputType()` `optional string input_type = 2;`
`ByteString` `getInputTypeBytes()` `optional string input_type = 2;`
`java.lang.String` `getName()` `optional string name = 1;`
`ByteString` `getNameBytes()` `optional string name = 1;`
`DescriptorProtos.MethodOptions` `getOptions()` `optional .google.protobuf.MethodOptions options = 4;`
`DescriptorProtos.MethodOptionsOrBuilder` `getOptionsOrBuilder()` `optional .google.protobuf.MethodOptions options = 4;`
`java.lang.String` `getOutputType()` `optional string output_type = 3;`
`ByteString` `getOutputTypeBytes()` `optional string output_type = 3;`
`Parser<DescriptorProtos.MethodDescriptorProto>` `getParserForType()` Gets the parser for a message of the same type as this message.
`int` `getSerializedSize()` Get the number of bytes required to encode this message.
`UnknownFieldSet` `getUnknownFields()` Get the `UnknownFieldSet` for this message.
`boolean` `hasInputType()` `optional string input_type = 2;`
`boolean` `hasName()` `optional string name = 1;`
`boolean` `hasOptions()` `optional .google.protobuf.MethodOptions options = 4;`
`boolean` `hasOutputType()` `optional string output_type = 3;`
`protected GeneratedMessage.FieldAccessorTable` `internalGetFieldAccessorTable()` Get the FieldAccessorTable for this type.
`boolean` `isInitialized()` Returns true if all required fields in the message and all embedded messages are set, false otherwise.
`static DescriptorProtos.MethodDescriptorProto.Builder` `newBuilder()`
`static DescriptorProtos.MethodDescriptorProto.Builder` `newBuilder​(DescriptorProtos.MethodDescriptorProto prototype)`
`DescriptorProtos.MethodDescriptorProto.Builder` `newBuilderForType()` Constructs a new builder for a message of the same type as this message.
`protected DescriptorProtos.MethodDescriptorProto.Builder` `newBuilderForType​(GeneratedMessage.BuilderParent parent)`
`static DescriptorProtos.MethodDescriptorProto` `parseDelimitedFrom​(java.io.InputStream input)`
`static DescriptorProtos.MethodDescriptorProto` `parseDelimitedFrom​(java.io.InputStream input, ExtensionRegistryLite extensionRegistry)`
`static DescriptorProtos.MethodDescriptorProto` `parseFrom​(byte[] data)`
`static DescriptorProtos.MethodDescriptorProto` `parseFrom​(byte[] data, ExtensionRegistryLite extensionRegistry)`
`static DescriptorProtos.MethodDescriptorProto` `parseFrom​(ByteString data)`
`static DescriptorProtos.MethodDescriptorProto` `parseFrom​(ByteString data, ExtensionRegistryLite extensionRegistry)`
`static DescriptorProtos.MethodDescriptorProto` `parseFrom​(CodedInputStream input)`
`static DescriptorProtos.MethodDescriptorProto` `parseFrom​(CodedInputStream input, ExtensionRegistryLite extensionRegistry)`
`static DescriptorProtos.MethodDescriptorProto` `parseFrom​(java.io.InputStream input)`
`static DescriptorProtos.MethodDescriptorProto` `parseFrom​(java.io.InputStream input, ExtensionRegistryLite extensionRegistry)`
`DescriptorProtos.MethodDescriptorProto.Builder` `toBuilder()` Constructs a builder initialized with the current message.
`protected java.lang.Object` `writeReplace()` Replaces this object in the output stream with a serialized form.
`void` `writeTo​(CodedOutputStream output)` Serializes the message and writes it to `output`.

### Methods inherited from class com.google.protobuf.GeneratedMessage

`getAllFields, getDescriptorForType, getField, getOneofFieldDescriptor, getRepeatedField, getRepeatedFieldCount, hasField, hasOneof, makeExtensionsImmutable, newFileScopedGeneratedExtension, newFileScopedGeneratedExtension, newMessageScopedGeneratedExtension, newMessageScopedGeneratedExtension, parseUnknownField`

### Methods inherited from class com.google.protobuf.AbstractMessage

`equals, findInitializationErrors, getInitializationErrorString, hashCode, hashFields, toString`

### Methods inherited from class com.google.protobuf.AbstractMessageLite

`checkByteStringIsUtf8, toByteArray, toByteString, writeDelimitedTo, writeTo`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface com.google.protobuf.MessageLite

`toByteArray, toByteString, writeDelimitedTo, writeTo`

### Methods inherited from interface com.google.protobuf.MessageOrBuilder

`findInitializationErrors, getAllFields, getDescriptorForType, getField, getInitializationErrorString, getOneofFieldDescriptor, getRepeatedField, getRepeatedFieldCount, hasField, hasOneof`

### Field Detail

#### PARSER

    public static Parser<DescriptorProtos.MethodDescriptorProto> PARSER

#### NAME_FIELD_NUMBER

    public static final int NAME_FIELD_NUMBER

See Also:
  Constant Field Values

#### INPUT_TYPE_FIELD_NUMBER

    public static final int INPUT_TYPE_FIELD_NUMBER

See Also:
  Constant Field Values

#### OUTPUT_TYPE_FIELD_NUMBER

    public static final int OUTPUT_TYPE_FIELD_NUMBER

See Also:
  Constant Field Values

#### OPTIONS_FIELD_NUMBER

    public static final int OPTIONS_FIELD_NUMBER

See Also:
  Constant Field Values

### Method Detail

#### getDefaultInstance

    public static DescriptorProtos.MethodDescriptorProto getDefaultInstance()

#### getDefaultInstanceForType

    public DescriptorProtos.MethodDescriptorProto getDefaultInstanceForType()

Description copied from interface: `MessageLiteOrBuilder`
Get an instance of the type with no fields set. Because no fields are set, all getters for singular fields will return default values and repeated fields will appear empty. This may or may not be a singleton. This differs from the `getDefaultInstance()` method of generated message classes in that this method is an abstract method of the `MessageLite` interface whereas `getDefaultInstance()` is a static method of a specific class. They return the same thing.

Specified by:
  `getDefaultInstanceForType` in interface `MessageLiteOrBuilder`
Specified by:
  `getDefaultInstanceForType` in interface `MessageOrBuilder`

#### getUnknownFields

    public final UnknownFieldSet getUnknownFields()

Description copied from interface: `MessageOrBuilder`
Get the `UnknownFieldSet` for this message.

Specified by:
  `getUnknownFields` in interface `MessageOrBuilder`
Overrides:
  `getUnknownFields` in class `GeneratedMessage`

#### getDescriptor

    public static final Descriptors.Descriptor getDescriptor()

#### internalGetFieldAccessorTable

    protected GeneratedMessage.FieldAccessorTable internalGetFieldAccessorTable()

Description copied from class: `GeneratedMessage`
Get the FieldAccessorTable for this type. We can't have the message class pass this in to the constructor because of bootstrapping trouble with DescriptorProtos.

Specified by:
  `internalGetFieldAccessorTable` in class `GeneratedMessage`

#### getParserForType

    public Parser<DescriptorProtos.MethodDescriptorProto> getParserForType()

Description copied from interface: `MessageLite`
Gets the parser for a message of the same type as this message.

Specified by:
  `getParserForType` in interface `Message`
Specified by:
  `getParserForType` in interface `MessageLite`
Overrides:
  `getParserForType` in class `GeneratedMessage`

#### hasName

    public boolean hasName()

`optional string name = 1;`

Specified by:
  `hasName` in interface `DescriptorProtos.MethodDescriptorProtoOrBuilder`

#### getName

    public java.lang.String getName()

`optional string name = 1;`

Specified by:
  `getName` in interface `DescriptorProtos.MethodDescriptorProtoOrBuilder`

#### getNameBytes

    public ByteString getNameBytes()

`optional string name = 1;`

Specified by:
  `getNameBytes` in interface `DescriptorProtos.MethodDescriptorProtoOrBuilder`

#### hasInputType

    public boolean hasInputType()

`optional string input_type = 2;`

     Input and output type names.  These are resolved in the same way as
     FieldDescriptorProto.type_name, but must refer to a message type.

Specified by:
  `hasInputType` in interface `DescriptorProtos.MethodDescriptorProtoOrBuilder`

#### getInputType

    public java.lang.String getInputType()

`optional string input_type = 2;`

     Input and output type names.  These are resolved in the same way as
     FieldDescriptorProto.type_name, but must refer to a message type.

Specified by:
  `getInputType` in interface `DescriptorProtos.MethodDescriptorProtoOrBuilder`

#### getInputTypeBytes

    public ByteString getInputTypeBytes()

`optional string input_type = 2;`

     Input and output type names.  These are resolved in the same way as
     FieldDescriptorProto.type_name, but must refer to a message type.

Specified by:
  `getInputTypeBytes` in interface `DescriptorProtos.MethodDescriptorProtoOrBuilder`

#### hasOutputType

    public boolean hasOutputType()

`optional string output_type = 3;`

Specified by:
  `hasOutputType` in interface `DescriptorProtos.MethodDescriptorProtoOrBuilder`

#### getOutputType

    public java.lang.String getOutputType()

`optional string output_type = 3;`

Specified by:
  `getOutputType` in interface `DescriptorProtos.MethodDescriptorProtoOrBuilder`

#### getOutputTypeBytes

    public ByteString getOutputTypeBytes()

`optional string output_type = 3;`

Specified by:
  `getOutputTypeBytes` in interface `DescriptorProtos.MethodDescriptorProtoOrBuilder`

#### hasOptions

    public boolean hasOptions()

`optional .google.protobuf.MethodOptions options = 4;`

Specified by:
  `hasOptions` in interface `DescriptorProtos.MethodDescriptorProtoOrBuilder`

#### getOptions

    public DescriptorProtos.MethodOptions getOptions()

`optional .google.protobuf.MethodOptions options = 4;`

Specified by:
  `getOptions` in interface `DescriptorProtos.MethodDescriptorProtoOrBuilder`

#### getOptionsOrBuilder

    public DescriptorProtos.MethodOptionsOrBuilder getOptionsOrBuilder()

`optional .google.protobuf.MethodOptions options = 4;`

Specified by:
  `getOptionsOrBuilder` in interface `DescriptorProtos.MethodDescriptorProtoOrBuilder`

#### isInitialized

    public final boolean isInitialized()

Description copied from interface: `MessageLiteOrBuilder`
Returns true if all required fields in the message and all embedded messages are set, false otherwise.

See also: `MessageOrBuilder.getInitializationErrorString()`

Specified by:
  `isInitialized` in interface `MessageLiteOrBuilder`
Overrides:
  `isInitialized` in class `GeneratedMessage`

#### writeTo

    public void writeTo​(CodedOutputStream output)
                 throws java.io.IOException

Description copied from interface: `MessageLite`
Serializes the message and writes it to `output`. This does not flush or close the stream.

Specified by:
  `writeTo` in interface `MessageLite`
Overrides:
  `writeTo` in class `AbstractMessage`
Throws:
  `java.io.IOException`

#### getSerializedSize

    public int getSerializedSize()

Description copied from interface: `MessageLite`
Get the number of bytes required to encode this message. The result is only computed on the first call and memoized after that.

Specified by:
  `getSerializedSize` in interface `MessageLite`
Overrides:
  `getSerializedSize` in class `AbstractMessage`

#### writeReplace

    protected java.lang.Object writeReplace()
                                     throws java.io.ObjectStreamException

Description copied from class: `GeneratedMessage`
Replaces this object in the output stream with a serialized form. Part of Java's serialization magic. Generated sub-classes must override this method by calling `return super.writeReplace();`

Overrides:
  `writeReplace` in class `GeneratedMessage`
Returns:
  a SerializedForm of this message
Throws:
  `java.io.ObjectStreamException`

#### parseFrom

    public static DescriptorProtos.MethodDescriptorProto parseFrom​(ByteString data)
                                                            throws InvalidProtocolBufferException

Throws:
  `InvalidProtocolBufferException`

#### parseFrom

    public static DescriptorProtos.MethodDescriptorProto parseFrom​(ByteString data,
                                                                   ExtensionRegistryLite extensionRegistry)
                                                            throws InvalidProtocolBufferException

Throws:
  `InvalidProtocolBufferException`

#### parseFrom

    public static DescriptorProtos.MethodDescriptorProto parseFrom​(byte[] data)
                                                            throws InvalidProtocolBufferException

Throws:
  `InvalidProtocolBufferException`

#### parseFrom

    public static DescriptorProtos.MethodDescriptorProto parseFrom​(byte[] data,
                                                                   ExtensionRegistryLite extensionRegistry)
                                                            throws InvalidProtocolBufferException

Throws:
  `InvalidProtocolBufferException`

#### parseFrom

    public static DescriptorProtos.MethodDescriptorProto parseFrom​(java.io.InputStream input)
                                                            throws java.io.IOException

Throws:
  `java.io.IOException`

#### parseFrom

    public static DescriptorProtos.MethodDescriptorProto parseFrom​(java.io.InputStream input,
                                                                   ExtensionRegistryLite extensionRegistry)
                                                            throws java.io.IOException

Throws:
  `java.io.IOException`

#### parseDelimitedFrom

    public static DescriptorProtos.MethodDescriptorProto parseDelimitedFrom​(java.io.InputStream input)
                                                                     throws java.io.IOException

Throws:
  `java.io.IOException`

#### parseDelimitedFrom

    public static DescriptorProtos.MethodDescriptorProto parseDelimitedFrom​(java.io.InputStream input,
                                                                            ExtensionRegistryLite extensionRegistry)
                                                                     throws java.io.IOException

Throws:
  `java.io.IOException`

#### parseFrom

    public static DescriptorProtos.MethodDescriptorProto parseFrom​(CodedInputStream input)
                                                            throws java.io.IOException

Throws:
  `java.io.IOException`

#### parseFrom

    public static DescriptorProtos.MethodDescriptorProto parseFrom​(CodedInputStream input,
                                                                   ExtensionRegistryLite extensionRegistry)
                                                            throws java.io.IOException

Throws:
  `java.io.IOException`

#### newBuilder

    public static DescriptorProtos.MethodDescriptorProto.Builder newBuilder()

#### newBuilderForType

    public DescriptorProtos.MethodDescriptorProto.Builder newBuilderForType()

Description copied from interface: `MessageLite`
Constructs a new builder for a message of the same type as this message.

Specified by:
  `newBuilderForType` in interface `Message`
Specified by:
  `newBuilderForType` in interface `MessageLite`

#### newBuilder

    public static DescriptorProtos.MethodDescriptorProto.Builder newBuilder​(DescriptorProtos.MethodDescriptorProto prototype)

#### toBuilder

    public DescriptorProtos.MethodDescriptorProto.Builder toBuilder()

Description copied from interface: `MessageLite`
Constructs a builder initialized with the current message. Use this to derive a new message from the current one.

Specified by:
  `toBuilder` in interface `Message`
Specified by:
  `toBuilder` in interface `MessageLite`

#### newBuilderForType

    protected DescriptorProtos.MethodDescriptorProto.Builder newBuilderForType​(GeneratedMessage.BuilderParent parent)

Specified by:
  `newBuilderForType` in class `GeneratedMessage`